// ConvertCP.h : Declaration of the CConvertCP

#ifndef __CONVERTCP_H_
#define __CONVERTCP_H_

#include "resource.h"       // main symbols

#define INITWCBSIZE	1024
#define INITMBBSIZE	512
#define INCRWCBSIZE	INITWCBSIZE
#define INCRMBBSIZE	INITMBBSIZE

#define MEMTYPE GHND

/////////////////////////////////////////////////////////////////////////////
// CConvertCP
class ATL_NO_VTABLE CConvertCP : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CConvertCP, &CLSID_ConvertCP>,
	public ISupportErrorInfo,
	public IDispatchImpl<IConvertCP, &IID_IConvertCP, &LIBID_CPCONVERTLib>
{
public:
	enum BuffTypes
	{
		WCBtype,
		MBBtype
	} BuffType;

	CConvertCP() : 
		m_lpszWideCharsBuff(NULL),
		m_lpszMultiBytesBuff(NULL),
		m_dwWideCharsBuff(0),
		m_dwMultiBytesBuff(0),
		m_hWideCharsBuff(NULL),
		m_hMultiBytesBuff(NULL),
		m_dwBufferLength(max(INITWCBSIZE,INITMBBSIZE)), 
		m_dwBufferIncrement(max(INCRWCBSIZE,INCRMBBSIZE))
	{
	}

	virtual ~CConvertCP()
	{
	}

DECLARE_REGISTRY_RESOURCEID(IDR_CONVERTCP)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CConvertCP)
	COM_INTERFACE_ENTRY(IConvertCP)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
END_COM_MAP()

// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IConvertCP
public:
	STDMETHOD(get_BufferIncrement)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_BufferIncrement)(/*[in]*/ long newVal);
	STDMETHOD(get_BufferLength)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_BufferLength)(/*[in]*/ long newVal);
	STDMETHOD(Convert)(/*[in]*/ int nCPFrom, /*[in]*/ int nCPTo, /*[in]*/ BSTR strFrom, /*[out, retval]*/ LPBSTR strOut);

	HRESULT FinalConstruct();
	void FinalRelease();

protected:
	DWORD CreateBuffers(DWORD dwWCBsize = INITWCBSIZE, DWORD dwMBBsize = INITMBBSIZE);
	DWORD ReleaseBuffers();
	DWORD ReAllocBuffer(DWORD dwNewSize, BuffTypes BuffType, BOOL bApplyIncriment = TRUE);

	LPWSTR m_lpszWideCharsBuff;
	LPSTR m_lpszMultiBytesBuff;
	HGLOBAL m_hWideCharsBuff;
	HGLOBAL m_hMultiBytesBuff;
	DWORD m_dwWideCharsBuff;
	DWORD m_dwMultiBytesBuff;
	DWORD m_dwBufferLength;
	DWORD m_dwBufferIncrement;
};

#endif //__CONVERTCP_H_
